package quickbuilder;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.lang.reflect.Array;
import java.security.InvalidParameterException;
import java.util.ArrayList;
import java.util.zip.GZIPInputStream;

import javax.swing.*;

import nbt.Tag;
import nbt.TagByteArray;
import nbt.TagInputStream;
import nbt.TagOutputStream;

import pfaeff.RegionFileIO;

import region.RegionFile;
import region.RegionFileCache;

public class Main extends JFrame
{
	public Container container;
	JTextField t1;
	JTextField t2;
	JTextField t3;
	JTextField t4;
	JTextField t5;
	JTextField t6;
	JTextField t7;
	JComboBox c1;
	JLabel l1;
	JLabel l2;
	JLabel l3;
	JLabel l4;
	JLabel l5;
	JLabel l6;
	JLabel l7;
	JButton b1;
	String[] foldernames;
	File topFolder;

	public Main()
	{
		super();
		setTitle("Minecraft Quickbuilder");
		container = getContentPane();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setUndecorated(false);
		setLayout(null);
		pack();
		setVisible(true);
		setBounds(200, 200, 255, 185);
		setResizable(false);
		init();
		b1.addMouseListener(new MouseListener()
		{
			public void mouseClicked(MouseEvent arg0)
			{

			}

			public void mouseEntered(MouseEvent arg0)
			{

			}

			public void mouseExited(MouseEvent arg0)
			{

			}

			public void mousePressed(MouseEvent arg0)
			{
				execute();
			}

			public void mouseReleased(MouseEvent arg0)
			{

			}
		});
		repaint();
	}

	public void init()
	{
		int Width = (int) getSize().getWidth();
		int Height = (int) getSize().getHeight();

		// collectfiles
		if (true)
		{
			topFolder = new File("C:\\Users\\" + System.getProperty("user.name") + "\\AppData\\Roaming\\.minecraft\\saves");
			// System.out.println("C:\\Users\\"+System.getProperty("user.name")+"\\AppData\\Roaming\\.minecraft\\saves");

			File[] folders = topFolder.listFiles(new FileFilter()
			{
				public boolean accept(File e)
				{
					return e.isDirectory();
				}
			});
			int beginfilenaam = topFolder.toString().length() + 1;
			foldernames = new String[folders.length];
			for (int i = 0; i < folders.length;)
			{
				foldernames[i] = folders[i].toString().substring(beginfilenaam);
				// System.out.println(foldernames[i]);
				i++;
			}
		}

		// create Gui elements
		l1 = new JLabel();
		l2 = new JLabel();
		l3 = new JLabel();
		l4 = new JLabel();
		l5 = new JLabel();
		l6 = new JLabel();
		l7 = new JLabel();
		t1 = new JTextField();
		t2 = new JTextField();
		t3 = new JTextField();
		t4 = new JTextField();
		t5 = new JTextField();
		t6 = new JTextField();
		t7 = new JTextField();
		c1 = new JComboBox(foldernames);
		b1 = new JButton();

		// set propertys gui elements
		l1.setBounds(5, 55, 20, 20);
		l2.setBounds(5, 80, 20, 20);
		l3.setBounds(5, 105, 20, 20);
		l4.setBounds(30, 30, 100, 20);
		l5.setBounds(135, 30, 100, 20);
		l6.setBounds(5, 130, 50, 20);
		l7.setBounds(5, 5, 50, 20);
		l1.setText("X:");
		l2.setText("Y:");
		l3.setText("Z:");
		l4.setText("Min");
		l5.setText("Max");
		l6.setText("Block ID");
		l7.setText("World: ");
		t1.setBounds(30, 55, 100, 20);
		t2.setBounds(30, 80, 100, 20);
		t3.setBounds(30, 105, 100, 20);
		t4.setBounds(135, 55, 100, 20);
		t5.setBounds(135, 80, 100, 20);
		t6.setBounds(135, 105, 100, 20);
		t7.setBounds(60, 130, 100, 20);
		c1.setBounds(55, 5, 100, 20);
		b1.setBounds(165, 130, 70, 20);
		b1.setText("execute");
		b1.setMargin(new Insets(5, 2, 5, 2));

		// add gui elements
		container.add(l1);
		container.add(l2);
		container.add(l3);
		container.add(l4);
		container.add(l5);
		container.add(l6);
		container.add(l7);
		container.add(t1);
		container.add(t2);
		container.add(t3);
		container.add(t4);
		container.add(t5);
		container.add(t6);
		container.add(t7);
		container.add(b1);
		container.add(c1);
	}

	public static void main(String[] arg0)
	{
		new Main();
	}

	public void execute()
	{
		try
		{
			if (t1.getText().isEmpty() || t2.getText().isEmpty() || t3.getText().isEmpty() || t4.getText().isEmpty() || t5.getText().isEmpty() || t6.getText().isEmpty() || t7.getText().isEmpty())
			{
				throw new NullPointerException("textfield leeg");
			}
			else
			{

				ArrayList<Block> blocks = berekenBlocks();
				// System.out.println(blocks);
				if (blocks.size() > 0)
				{
					changeBlocks(blocks, new File("C:\\Users\\" + System.getProperty("user.name") + "\\AppData\\Roaming\\.minecraft\\saves\\" + c1.getSelectedItem()));
				}
				else
				{
					try
					{
						throw new NullPointerException("Max waarde is grooter dan min waarde");
					} catch (NullPointerException e)
					{
						JOptionPane.showMessageDialog(this, "Max waarde moet groter zijn dan min waarde", "NullPointerException", JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		} catch (NullPointerException e)
		{
			JOptionPane.showMessageDialog(this, "Fill all fields", "NullPointerException", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}
	}

	void changeBlocks(ArrayList<Block> blocks, File Location)
	{
		try
		{
			// load regions
			ArrayList<ArrayList<Block>> BPR = new ArrayList<ArrayList<Block>>();
			ArrayList<RegionFile> regions = new ArrayList<RegionFile>();
			for (int i = 0; i < blocks.size();)
			{
				Boolean a = false;
				int x = (int) Math.floor((double) blocks.get(i).x / 512);
				int z = (int) Math.floor((double) blocks.get(i).z / 512);
				File checker = new File(Location + "//region//r." + x + "." + z + ".mcr");
				System.out.println(checker);
				if (!checker.isFile())
				{
					throw new IOException("Area not Explored");
				}
				RegionFile regionFile = RegionFileCache.getRegionFile(Location, x, z);
				for (int j = 0; j < regions.size();)
				{
					if (regions.get(j).toString().equals(regionFile.toString()))
					{
						BPR.get(j).add(blocks.get(i));
						a = true;
						break;
					}
					j++;
				}
				if (!a)
				{
					ArrayList<Block> b = new ArrayList<Block>();
					b.add(blocks.get(i));
					BPR.add(b);
					regions.add(regionFile);
				}
				i++;
			}
			// load chunks
			ArrayList<ArrayList<DataInputStream>> CPR = new ArrayList<ArrayList<DataInputStream>>();
			ArrayList<ArrayList<ArrayList<Block>>> BPCPR = new ArrayList<ArrayList<ArrayList<Block>>>();
			ArrayList<ArrayList<MCCPoint>> PPR = new ArrayList<ArrayList<MCCPoint>>();

			for (int i = 0; i < regions.size();)
			{
				PPR.add(new ArrayList<MCCPoint>());
				CPR.add(new ArrayList<DataInputStream>());
				BPCPR.add(new ArrayList<ArrayList<Block>>());
				for (int j = 0; j < BPR.get(i).size();)
				{
					int Chunkx = (int) Math.floor(((double) BPR.get(i).get(j).x % 512) / 16);
					int Chunkz = (int) Math.floor(((double) BPR.get(i).get(j).z % 512) / 16);
					DataInputStream input = regions.get(i).getChunkDataInputStream(Chunkx, Chunkz);
					MCCPoint point = new MCCPoint(Chunkx, Chunkz);
					// System.out.println(point);
					Boolean a = false;
					for (int k = 0; k < PPR.get(i).size();)
					{
						if (PPR.get(i).get(k).toString().equals(point.toString()))
						{
							a = true;
							BPCPR.get(i).get(k).add(BPR.get(i).get(j));
							break;
						}
						k++;
					}
					if (!a)
					{
						PPR.get(i).add(point);
						CPR.get(i).add(input);
						ArrayList<Block> b = new ArrayList<Block>();
						b.add(BPR.get(i).get(j));
						BPCPR.get(i).add(b);
					}
					j++;
				}
				i++;
			}
			// mod chunks
			for (int i = 0; i < regions.size();)
			{
				for (int j = 0; j < CPR.get(i).size();)
				{
					Tag root = (new TagInputStream(CPR.get(i).get(j))).readTag(true);
					CPR.get(i).get(j).close();

					TagByteArray t = (TagByteArray) root.findChildByName("Blocks", true);
					// System.out.println(t);
					for (int k = 0; k < BPCPR.get(i).get(j).size();)
					{
						Block ab = BPCPR.get(i).get(j).get(k);
						t.payload[(ab.y % 16) + ((ab.z % 16) * 128 + ((ab.x % 16) * 2048))] = (byte) ab.ID;
						k++;
					}
					DataOutputStream output = regions.get(i).getChunkDataOutputStream(PPR.get(i).get(j).x, PPR.get(i).get(j).z);
					(new TagOutputStream(output)).writeTag(root, true);
					output.close();
					j++;
				}
				i++;
			}

		} catch (IOException e)
		{
			JOptionPane.showMessageDialog(this, "Area not Explored", "IOException", JOptionPane.ERROR_MESSAGE);
		}
	}

	public ArrayList<Block> berekenBlocks()
	{
		ArrayList<Block> blocks = new ArrayList<Block>();
		try
		{
			for (int i = Integer.parseInt(t1.getText()); i < Integer.parseInt(t4.getText());)
			{
				for (int j = Integer.parseInt(t2.getText()); j < Integer.parseInt(t5.getText());)
				{
					for (int k = Integer.parseInt(t3.getText()); k < Integer.parseInt(t6.getText());)
					{
						blocks.add(new Block(i, k, j, Integer.parseInt(t7.getText())));
						k++;
					}
					j++;
				}
				i++;
			}
			return blocks;
		} catch (java.lang.NumberFormatException e)
		{
			JOptionPane.showMessageDialog(this, "Numbers Only", "NumberFormatException", JOptionPane.ERROR_MESSAGE);
			return (new ArrayList<Block>());
		}
	}
}